module CountdownNumbers

import Combinatorics: combinations

export numbers

include("types.jl")

const formula_cache = Dict{Vector{Int}, Set{Union{Integer, Operation}}}()
const formula_cache_lock = ReentrantLock()

include("public.jl")

include("cache.jl")
include("field_getters.jl")
include("generate_formulas.jl")
include("show.jl")
include("type_constructors.jl")

end # module
