@inline function _formula_cache_read(key::Vector{Int})::Set{Union{Integer, Operation}}
    return lock(formula_cache_lock) do
        get(formula_cache, key, Set{Expr}())
    end
end

@inline function _formula_cache_write(key::Vector{Int},
                                      value::Set{Union{Integer, Operation}})::Set{Union{Integer, Operation}}
    lock(formula_cache_lock) do
        formula_cache[key] = value
    end
    return value
end
