import Combinatorics: combinations

@inline function numbers(xs::AbstractVector{<:Integer}, target::Integer)
    isempty(xs) && throw(ArgumentError("First argument must be nonempty"))
    current_solution = xs[1]
    current_value = _value(current_solution)
    current_error = abs(target - current_value)
    for x in xs
        new_error = abs(target - x)
        if new_error <= current_error
            current_solution = x
            current_value = x
            current_error = new_error
            current_error == 0 && return current_solution
        end
    end
    for subset in combinations(xs)
        if length(subset) >= 2
            for f in _all_formulas(subset)
                if _isvalid(f)
                    new_solution = f
                    new_value = _value(new_solution)
                    new_error = abs(target - new_value)
                    if new_error < current_error
                        current_solution = new_solution
                        current_value = new_value
                        current_error = new_error
                        @debug("", current_value, current_error, current_solution)
                        current_error == 0 && return current_solution
                    end
                end
            end
        end
    end
    @warn("Could not find exact solution. Closest solution has L1 error $(current_error)")
    return current_solution
end
