function Base.show(io::IO, z::Operation)
    print(io,
          "CountdownNumbers.Operation: ",
          _as_string(z),
          " = ",
          _as_string(_value(z)),)
end

@inline _as_string_with_parens(z::Operation) = string("(", _as_string(z), ")")
@inline _as_string_with_parens(i::Integer) = string(i)

@inline _as_string(i::Integer) = string(i)

@inline function _as_string(z::Add)
    return string(_as_string_with_parens(z.x),
                  " + ",
                  _as_string_with_parens(z.y))
end

@inline function _as_string(z::Subtract)
    return string(_as_string_with_parens(z.x),
                  " - ",
                  _as_string_with_parens(z.y))
end

@inline function _as_string(z::Multiply)
    return string(_as_string_with_parens(z.x),
                  " * ",
                  _as_string_with_parens(z.y))
end

@inline function _as_string(z::Divide)
    return string(_as_string_with_parens(z.x),
                  " / ",
                  _as_string_with_parens(z.y))
end
