@inline function Add(x::Union{Integer, Operation}, y::Union{Integer, Operation})
    x_value = _value(x)
    y_value = _value(y)
    z_value = Int(x_value + y_value)
    if z_value > 0
        return Add(x, y, true, z_value)
    else
        return Add(x, y, false, z_value)
    end
end

@inline function Subtract(x::Union{Integer, Operation}, y::Union{Integer, Operation})
    x_value = _value(x)
    y_value = _value(y)
    z_value = Int(x_value - y_value)
    if z_value > 0
        return Subtract(x, y, true, z_value)
    else
        return Subtract(x, y, false, z_value)
    end
end

@inline function Multiply(x::Union{Integer, Operation}, y::Union{Integer, Operation})
    x_value = _value(x)
    y_value = _value(y)
    z_value = Int(x_value * y_value)
    if z_value > 0
        return Multiply(x, y, true, z_value)
    else
        return Multiply(x, y, false, z_value)
    end
end

@inline function Divide(x::Union{Integer, Operation}, y::Union{Integer, Operation})
    x_value = _value(x)
    y_value = _value(y)
    try
        z_value = Int(x_value // y_value)
        if z_value > 0
            return Divide(x, y, true, z_value)
        else
            return Divide(x, y, false, z_value)
        end
    catch e
        e isa InexactError || rethrow(e)
        return Divide(x, y, false, 0)
    end
end
